/* Generated by re2c 0.13.5 on Mon Jun 18 14:19:42 2012 */
#line 1 "TRConfigLexer.re"
/*
 * TRConfigLexer.re
 * Configuration Lexer
 *
 * Author: Landon Fuller <landonf@threerings.net>
 *
 * Copyright (c) 2006 Three Rings Design, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of any contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include "TRConfigLexer.h"

#include "TRConfigParser.h"

/*
 * re2c Configuration
 */
#define YYCTYPE      char	/* Input Symbol Type */
#define YYCURSOR     _cursor	/* L-expression of type *YYCTYPE that points to the current input symbol */
#define YYLIMIT      _limit	/* Expression of type *YYCTYPE that marks the end of the buffer */
#define YYMARKER     _marker	/* L-expression of type *YYCTYPE that is used for backtracking information */
#define YYCTXMARKER  _ctxMarker /* L-expression of type *YYCTYPE that is used for trailing context back tracking information */
#define YYFILL(n)    [self fill: n]	/* YYFILL(n) is called when the buffer needs (re)filling */

#define YYDEBUG(state, current) printf("state: %d, current: '%c' (%d)\n", state, current, current);

/*
 * Macros
 */

/* Increment line count */
#define INCR_LINE()	_lineNumber++

/* Switch to a start condition */
#define BEGIN(cond)	( _condition = LEXER_SC_ ## cond)

/* Declare a start condition */
#define SC(cond)	LEXER_SC_ ## cond: LEXER_SC_ ## cond

/* Check for end-of-input */
#define CHECK_EOI()	if (_eoi) { return NULL; }

/* Skip a token */
#define SKIP(cond)	CHECK_EOI(); goto LEXER_SC_ ## cond

/* Get the current token length */
#define TOKEN_LENGTH()	((_eoi ? _eoi : _cursor) - _token)

@implementation TRConfigLexer

- (void) dealloc {
	if (buffer)
		munmap(buffer, bufferLength);
	[super dealloc];
}

- (id) initWithFD: (int) fd {
	struct stat statbuf;

	/* Initialize */
	self = [self init];
	if (self == NULL)
		return (self);

	/* Mmap() source file
	 * Unless our caller botched something, this should never fail */
	assert((fstat(fd, &statbuf) == 0));
	bufferLength = statbuf.st_size;
	buffer = mmap(NULL, bufferLength, PROT_READ, MAP_SHARED, fd, 0);
	assert(buffer != MAP_FAILED);

	/* Initialize lexer state */
	_lineNumber = 1;
	_condition = LEXER_SC_INITIAL;
	_cursor = buffer;
	_limit = _cursor + bufferLength - 1;

	return (self);
}

- (void) fill: (int) length {
	/* We just need to prevent re2c from walking off the end of our buffer */
	assert(_limit - _cursor >= 0);
	if (_cursor == _limit) {
		/* Save the cursor and signal EOI */
		_eoi = _cursor;
		_cursor = "\n";
	}
}

- (TRConfigToken *) scan {
	TRConfigToken *token;
	#line 130 "TRConfigLexer.re"


	switch (_condition) {
		case SC(INITIAL):
			_token = _cursor;
			
#line 137 "TRConfigLexer.m"
{
	YYCTYPE yych;

	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy2;
	case '\n':	goto yy10;
	case '#':	goto yy4;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy6;
	case '<':	goto yy8;
	default:	goto yy12;
	}
yy2:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy19;
yy3:
#line 138 "TRConfigLexer.re"
	{
				SKIP(INITIAL);
			}
#line 224 "TRConfigLexer.m"
yy4:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy17;
yy5:
#line 143 "TRConfigLexer.re"
	{
				SKIP(INITIAL);
			}
#line 234 "TRConfigLexer.m"
yy6:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy15;
yy7:
#line 148 "TRConfigLexer.re"
	{
				token = [[TRConfigToken alloc] initWithBytes: _token
								    numBytes: TOKEN_LENGTH()
								  lineNumber: _lineNumber
								     tokenID: TOKEN_KEY];
				BEGIN(VALUE);
				return token;
			}
#line 249 "TRConfigLexer.m"
yy8:
	++YYCURSOR;
#line 158 "TRConfigLexer.re"
	{
				SKIP(SECTION);
			}
#line 256 "TRConfigLexer.m"
yy10:
	++YYCURSOR;
#line 163 "TRConfigLexer.re"
	{
				INCR_LINE();
				SKIP(INITIAL);
			}
#line 264 "TRConfigLexer.m"
yy12:
	++YYCURSOR;
#line 169 "TRConfigLexer.re"
	{
				// TODO explode here
				printf("Unknown character: '%c' (%d)\n", yych, yych);
				return NULL;
			}
#line 273 "TRConfigLexer.m"
yy14:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy15:
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy14;
	default:	goto yy7;
	}
yy16:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy17:
	switch (yych) {
	case '\n':	goto yy5;
	default:	goto yy16;
	}
yy18:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy19:
	switch (yych) {
	case '\t':
	case ' ':	goto yy18;
	default:	goto yy3;
	}
}
#line 175 "TRConfigLexer.re"


			break;

		/* Section Declarations */
		case SC(SECTION):
			_token = _cursor;
			
#line 375 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy26;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy23;
	case '/':	goto yy25;
	default:	goto yy22;
	}
yy22:
yy23:
	YYCTXMARKER = YYCURSOR + 1;
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy32;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy23;
	case '>':	goto yy35;
	default:	goto yy22;
	}
yy25:
	yych = *++YYCURSOR;
	switch (yych) {
	case '>':	goto yy22;
	default:	goto yy29;
	}
yy26:
	++YYCURSOR;
#line 215 "TRConfigLexer.re"
	{
				INCR_LINE();
				SKIP(INITIAL);
			}
#line 538 "TRConfigLexer.m"
yy28:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy29:
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy28;
	case '>':	goto yy30;
	default:	goto yy22;
	}
yy30:
	++YYCURSOR;
#line 205 "TRConfigLexer.re"
	{
				/* Drop the leading '/' and trailing ">" */
				token = [[TRConfigToken alloc] initWithBytes: _token + 1
								    numBytes: TOKEN_LENGTH() - 2
								  lineNumber: _lineNumber
								     tokenID: TOKEN_SECTION_END];
				return token;
			}
#line 623 "TRConfigLexer.m"
yy32:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy32;
	default:	goto yy34;
	}
yy34:
	YYCURSOR = YYCTXMARKER;
#line 195 "TRConfigLexer.re"
	{
				token = [[TRConfigToken alloc] initWithBytes: _token
								    numBytes: TOKEN_LENGTH()
								  lineNumber: _lineNumber
								     tokenID: TOKEN_SECTION_START];
				BEGIN(SECTION_NAME);
				return token;
			}
#line 644 "TRConfigLexer.m"
yy35:
	++YYCURSOR;
#line 185 "TRConfigLexer.re"
	{
				/* Drop the trailing ">" */
				token = [[TRConfigToken alloc] initWithBytes: _token
								    numBytes: TOKEN_LENGTH() - 1
								  lineNumber: _lineNumber
								     tokenID: TOKEN_SECTION_START];
				return token;
			}
#line 656 "TRConfigLexer.m"
}
#line 220 "TRConfigLexer.re"


			break;

		case SC(SECTION_NAME):
			_token = _cursor;
			
#line 666 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy40;
	case '\n':	goto yy45;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy43;
	default:	goto yy39;
	}
yy39:
yy40:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy40;
	default:	goto yy42;
	}
yy42:
#line 228 "TRConfigLexer.re"
	{
				SKIP(SECTION_NAME);
			}
#line 756 "TRConfigLexer.m"
yy43:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy43;
	case '>':	goto yy47;
	default:	goto yy39;
	}
yy45:
	++YYCURSOR;
#line 244 "TRConfigLexer.re"
	{
				INCR_LINE();
				SKIP(INITIAL);
			}
#line 836 "TRConfigLexer.m"
yy47:
	++YYCURSOR;
#line 233 "TRConfigLexer.re"
	{
				/* Drop the trailing ">" */
				token = [[TRConfigToken alloc] initWithBytes: _token
								    numBytes: TOKEN_LENGTH() - 1
								  lineNumber: _lineNumber
								     tokenID: TOKEN_SECTION_NAME];
				BEGIN(INITIAL);
				return token;
			}
#line 849 "TRConfigLexer.m"
}
#line 249 "TRConfigLexer.re"


		/* Values */
		case SC(VALUE):
			_token = _cursor;
			
#line 858 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy51;
	case '\n':	goto yy62;
	case '"':	goto yy57;
	case '#':	goto yy54;
	default:	goto yy59;
	}
yy51:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy51;
	default:	goto yy53;
	}
yy53:
#line 255 "TRConfigLexer.re"
	{
				SKIP(VALUE);
			}
#line 885 "TRConfigLexer.m"
yy54:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':
	case '"':	goto yy64;
	case '\n':	goto yy56;
	default:	goto yy54;
	}
yy56:
#line 260 "TRConfigLexer.re"
	{
				SKIP(VALUE);
			}
#line 902 "TRConfigLexer.m"
yy57:
	++YYCURSOR;
#line 265 "TRConfigLexer.re"
	{
				SKIP(STRING_VALUE);
			}
#line 909 "TRConfigLexer.m"
yy59:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case '\n':
	case ' ':
	case '"':	goto yy61;
	default:	goto yy59;
	}
yy61:
#line 270 "TRConfigLexer.re"
	{ /* " vim syntax fix */
				token = [[TRConfigToken alloc] initWithBytes: _token
								    numBytes: TOKEN_LENGTH()
								  lineNumber: _lineNumber
								     tokenID: TOKEN_VALUE];
				return token;
			}
#line 930 "TRConfigLexer.m"
yy62:
	++YYCURSOR;
#line 279 "TRConfigLexer.re"
	{
				INCR_LINE();
				SKIP(INITIAL);
			}
#line 938 "TRConfigLexer.m"
yy64:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy56;
	default:	goto yy64;
	}
}
#line 284 "TRConfigLexer.re"

			break;

		/* Quoted string values */
		case SC(STRING_VALUE):
			_token = _cursor;

			
#line 957 "TRConfigLexer.m"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy74;
	case '"':	goto yy68;
	case '#':	goto yy69;
	default:	goto yy72;
	}
yy68:
	YYCURSOR = YYMARKER;
	switch (yyaccept) {
	case 0: 	goto yy71;
	case 1: 	goto yy75;
	}
yy69:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy72;
	case '"':	goto yy78;
	default:	goto yy69;
	}
yy71:
#line 294 "TRConfigLexer.re"
	{
				SKIP(STRING_VALUE);
			}
#line 990 "TRConfigLexer.m"
yy72:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy73:
	switch (yych) {
	case '"':	goto yy76;
	default:	goto yy72;
	}
yy74:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy73;
yy75:
#line 310 "TRConfigLexer.re"
	{
				INCR_LINE();
				SKIP(INITIAL);
			}
#line 1010 "TRConfigLexer.m"
yy76:
	++YYCURSOR;
#line 300 "TRConfigLexer.re"
	{
				/* Skip the trailing '"' */
				token = [[TRConfigToken alloc] initWithBytes: _token
								    numBytes: TOKEN_LENGTH() - 1
								  lineNumber: _lineNumber
								     tokenID: TOKEN_VALUE];
				return token;
			}
#line 1022 "TRConfigLexer.m"
yy78:
	yych = *++YYCURSOR;
	goto yy80;
yy79:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy80:
	switch (yych) {
	case '\n':	goto yy71;
	default:	goto yy79;
	}
}
#line 315 "TRConfigLexer.re"

			break;

		default:
			/* Impossible */
			assert(0);
	}

	/* Never reached */
	return nil;
}

@end
